package com.example.moulaye.quizapp;

import android.annotation.SuppressLint;
import android.app.Dialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.support.v7.app.AlertDialog;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.app.AppCompatDialogFragment;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.TextView;
import android.widget.Toast;
import java.util.Collections;
import java.util.List;

import static android.support.constraint.Constraints.TAG;


public class QuizActivity extends AppCompatActivity {
    private TextView textViewQuestion;
    private RadioGroup rbGroup;
    private RadioButton rb1;
    private RadioButton rb2;
    private RadioButton rb3;
    private Button buttonConfirmNext;
    private List<Question> questionList;
    private int questionCounter;
    private int questionCountTotal;
    private Question currentQuestion;
    private int score;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_quiz_start);


        textViewQuestion = findViewById(R.id.text_view_question);
        rbGroup = findViewById(R.id.radio_group);
        rb1 = findViewById(R.id.radio_button1);
        rb2 = findViewById(R.id.radio_button2);
        rb3 = findViewById(R.id.radio_button3);
        buttonConfirmNext = findViewById(R.id.button_confirm_next);


        QuizDbHelper dbHelper = new QuizDbHelper(this);
        questionList = dbHelper.getAllQuestions();
        questionCountTotal = questionList.size();
        Collections.shuffle(questionList);

        showNextQuestion();

        buttonConfirmNext.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                    if (rb1.isChecked() || rb2.isChecked() || rb3.isChecked()) {

                        RadioButton rbSelected = findViewById(rbGroup.getCheckedRadioButtonId());
                        int answerNr = rbGroup.indexOfChild(rbSelected) + 1;

                        if (answerNr == currentQuestion.getAnswerNr()) {
                            score++;


                            Toast.makeText(QuizActivity.this, "Bonne réponse!", Toast.LENGTH_SHORT).show();
                        }
                        else{
                            Toast.makeText(QuizActivity.this, "Mauvaise réponse", Toast.LENGTH_SHORT).show();
                        }

                        showNextQuestion();
                    }

            }
        });
}
    private void showNextQuestion() {


        if (questionCounter < questionCountTotal) {
            currentQuestion = questionList.get(questionCounter);

            textViewQuestion.setText(currentQuestion.getQuestion());
            rb1.setText(currentQuestion.getOption1());
            rb2.setText(currentQuestion.getOption2());
            rb3.setText(currentQuestion.getOption3());

            questionCounter++;

            buttonConfirmNext.setText("Confirmer");


        } else {
            finishQuiz();
        }
    }

    private void finishQuiz() {
        SharedPreferences prefs = getSharedPreferences("quizz_score", MODE_PRIVATE);
        int highscore = prefs.getInt("score",0);
        if (score >= highscore) {
            SharedPreferences.Editor editor = prefs.edit();
            editor.putLong("date",System.currentTimeMillis());
            editor.putInt("score", score);

            editor.commit();
        }

        finish();
    }
}
